/**
 *  @file    variable.h
 *  @author  Guillaume Bour. 2002
 
 *  @version 0.1
 *    @date  05/02/2002

 *  variables definition
 */
#ifndef _VARIABLE_H_
#define _VARIABLE_H_

#include <gtk/gtk.h>
#include "type.h"

/*>>> dfinition des variables                */
struct s_variable {
  gchar *name;       /**< variable name       */
  type_t type;       /**< variable type       */
  gpointer value;    /**< variable value      */
};


/*>>> functions prototypes                    */
struct s_variable *var_alloc(gchar *, type_t);
void var_free(gpointer, gpointer);
gint var_comparison(gconstpointer, gconstpointer);
#ifdef DEBUG1
void var_debug(gpointer, gpointer);
#endif

#endif /* _VARIABLE_H_ */
