
/*      Copyright (C) 2002 Guillaume Bour
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *  
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *  
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 59 Temple Place - Suite 330, Boston, 
 *      MA 02111-1307, USA.
 */
#include <gtk/gtk.h>
//#include <time.h>
#include <unistd.h>
#include "callbacks.h"
#include "interface.h"
#include "turtle.h"

//GdkPixmap *pixmap = NULL;
extern struct s_turtle my_turtle;

gint configure_event( GtkWidget         *widget,
		      GdkEventConfigure *event )
{
  GdkPixmap *pixmap = NULL;

  //  printf("configure event\n");

  if (pixmap)
    gdk_pixmap_unref(pixmap);
  
  pixmap = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);
  gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      0, 0,
		      widget->allocation.width,
		      widget->allocation.height);
  
  //  lafontaine_set_pixmap(pixmap);
  my_turtle.pixmap = pixmap;

  return TRUE;
}


gint expose_event(GtkWidget *widget,
		  GdkEventExpose *event )
{

  GdkGC *gc;
  //  GdkColor pencolor;
  //  GdkColormap *colormap;
  gboolean bb[1];

  //gc = gdk_gc_new(widget->window);
  //colormap = gtk_widget_get_colormap(widget);
  
  /*
  if(gdk_colormap_alloc_colors(cmap, &redc, 1, FALSE, FALSE, bb) > 0)
    { printf("color not allocated\n"); exit(0); }
  else
    { printf("pxl: %d\n", redc.pixel); }

  gdk_gc_set_foreground(mgc, &redc);
  gdk_gc_set_background(mgc, &redc);
  */
  /*  printf("expose event on drawing area: %d ::  %d, %d, %d , %d\n",
	 widget, 
	 event->area.x, event->area.y,
	 event->area.width, event->area.height);
  */
  gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  //gc,
		  //pixmap,
		  //lafontaine_get_pixmap(),
		  my_turtle.pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);
  
  gdk_flush();
  //  gdk_gc_destroy(gc);
  return FALSE;
}

gint motion_notify_event( GtkWidget *widget,
                                                  GdkEventMotion *event )
                 {
                   printf("motion notify event\n");                  
 
                   return TRUE;
                }

void show_callback(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gtk_widget_show(data);
}

void open_callback(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gchar *filename;

  gtk_widget_hide(data);
  filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(data));
  printf("filename: '%s'\n", filename);
}

gint switchitem_response(GtkWidget *widget, GdkEvent *event)
{
  printf("switchitem_response callback executed\n");

  /*  if(event->type == GDK_BUTTON_PRESS) 
      {*/
      if(gtk_notebook_get_current_page(GTK_NOTEBOOK(my_turtle.notebook)) == 0)
	{ gtk_notebook_set_page(GTK_NOTEBOOK(my_turtle.notebook), 1); }
      else
	{ gtk_notebook_set_page(GTK_NOTEBOOK(my_turtle.notebook), 0); }
      
      return TRUE;
      //    }

  /* Tell calling code that we have not handled this event; pass it on. */
      //  return FALSE;
}

gint drawitem_response(GtkWidget *widget, GdkEvent *event)
{
  printf("drawitem_response callback executed\n");

  my_turtle.draw = !my_turtle.draw;
  return TRUE;
}


gint choose_french(GtkWidget *widget, GdkEvent *event)
{
  printf("choose french language\n");

  my_turtle.language = LANG_FRENCH;
  return(TRUE);
}

gint choose_english(GtkWidget *widget, GdkEvent *event)
{
  printf("choose english language\n");

  my_turtle.language = LANG_ENGLISH;
  return(TRUE);
}


/* another callback */
gboolean quit_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  printf("quit event\n");
  return(FALSE);
}

void destroy(GtkWidget *widget, gpointer data)
{
  printf("destroy event\n");
  gtk_main_quit();
}



void exec_clb(GtkButton *button, gpointer source)
{
  gchar *code;


  /* lecture et affichage de texte */
  code = gtk_editable_get_chars(GTK_EDITABLE(source), 0, -1);
  g_message("code lu: '%s'\n", code);
  //gtk_text_insert(dbg, NULL, NULL, NULL, code, -1);
  
  /* initialisation de la compilation */
  mc_init();

  /* lancement de la compilation      */
  gtk_statusbar_push(GTK_STATUSBAR(my_turtle.status), 1, 
		     "*** compiling code source");
  launch_parser(code);

  /* affichage du code 3  adresses   */
#ifdef DEBUG1
  mc_debug();
#endif

  /* lancement de l'xcution         */
#ifdef DEBUG
  if(my_turtle.draw)
    {
#endif
      gtk_statusbar_push(GTK_STATUSBAR(my_turtle.status), 1, 
			 "*** executing compiled code");
      exec_all();
#ifdef DEBUG
    }
#endif

  /* dessin dans la drawing area */
  /*  if(! launch_parser(code))
    { 
      printf("end of parsing\n");
      lafontaine_draw_all(); 
      exec_all();
    }
  */
}

